> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tembo.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Create an MCP connection

> Create a new stdio or Streamable HTTP MCP connection. Remote connections support OAuth, client credentials, or static headers and begin authorization when required; stdio commands are stored but never executed by this API.



## OpenAPI

````yaml https://api.tembo.io/public-api/openapi/public post /v1/mcp-connections
openapi: 3.1.0
info:
  title: Tembo Public API
  description: Public API Endpoints for Tembo
  version: 1.0.0
servers:
  - url: https://api.tembo.io
    description: Tembo API
  - url: https://{deployment-origin}/api/public-api
    description: Self-hosted Tembo
    variables:
      deployment-origin:
        default: tembo.example.com
        description: Hostname of your self-hosted Tembo deployment
security: []
paths:
  /v1/mcp-connections:
    post:
      tags:
        - MCP Connections
      summary: Create an MCP connection
      description: >-
        Create a new stdio or Streamable HTTP MCP connection. Remote connections
        support OAuth, client credentials, or static headers and begin
        authorization when required; stdio commands are stored but never
        executed by this API.
      operationId: createMcpConnection
      parameters: []
      requestBody:
        content:
          application/json:
            schema:
              anyOf:
                - type: object
                  properties:
                    name:
                      type: string
                      minLength: 1
                      maxLength: 200
                    args:
                      type: array
                      items:
                        type: string
                        maxLength: 8192
                      maxItems: 100
                      default: []
                    command:
                      type: string
                      minLength: 1
                      maxLength: 4096
                    env:
                      type: object
                      propertyNames:
                        type: string
                        minLength: 1
                        maxLength: 256
                      additionalProperties:
                        type: string
                        maxLength: 16384
                    type:
                      type: string
                      const: stdio
                  required:
                    - name
                    - command
                    - type
                  additionalProperties: false
                - type: object
                  properties:
                    name:
                      type: string
                      minLength: 1
                      maxLength: 200
                    serverUrl:
                      type: string
                      format: uri
                    authType:
                      type: string
                      enum:
                        - oauth
                        - client_credentials
                        - static_headers
                      default: oauth
                    clientId:
                      type: string
                      minLength: 1
                      maxLength: 4096
                    clientSecret:
                      type: string
                      minLength: 1
                      maxLength: 65536
                    headers:
                      type: object
                      propertyNames:
                        type: string
                        minLength: 1
                        maxLength: 256
                      additionalProperties:
                        type: string
                        maxLength: 16384
                    oauthRegistration:
                      type: string
                      enum:
                        - automatic
                        - pre_registered
                      default: automatic
                    scope:
                      type: string
                      minLength: 1
                      maxLength: 4096
                    type:
                      type: string
                      const: remote
                      default: remote
                  required:
                    - name
                    - serverUrl
                  additionalProperties: false
      responses:
        '201':
          description: Create an MCP connection
          content:
            application/json:
              schema:
                type: object
                properties:
                  authorizationUrl:
                    type:
                      - string
                      - 'null'
                    format: uri
                  connection:
                    type: object
                    properties:
                      connectedAt:
                        type:
                          - string
                          - 'null'
                        format: date-time
                      id:
                        type: string
                        format: uuid
                      name:
                        type: string
                      serverUrl:
                        type:
                          - string
                          - 'null'
                      type:
                        type: string
                        enum:
                          - remote
                          - stdio
                      args:
                        type:
                          - array
                          - 'null'
                        items:
                          type: string
                          maxLength: 8192
                        maxItems: 100
                      authType:
                        type:
                          - string
                          - 'null'
                        enum:
                          - oauth
                          - client_credentials
                          - static_headers
                          - null
                      command:
                        type:
                          - string
                          - 'null'
                      createdAt:
                        type: string
                        format: date-time
                      envKeys:
                        type: array
                        items:
                          type: string
                      headerKeys:
                        type: array
                        items:
                          type: string
                      updatedAt:
                        type: string
                        format: date-time
                    required:
                      - connectedAt
                      - id
                      - name
                      - serverUrl
                      - type
                      - args
                      - authType
                      - command
                      - createdAt
                      - envKeys
                      - headerKeys
                      - updatedAt
                    additionalProperties: false
                required:
                  - authorizationUrl
                  - connection
                additionalProperties: false
        '400':
          description: Validation error or missing resource scope
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                required:
                  - error
                additionalProperties: false
        '404':
          description: MCP connection not found
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                required:
                  - error
                additionalProperties: false
        '409':
          description: MCP connection conflict or unsupported action
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                required:
                  - error
                additionalProperties: false
        '500':
          description: MCP connection operation failed
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                required:
                  - error
                additionalProperties: false
        '502':
          description: The remote MCP server operation failed
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                required:
                  - error
                additionalProperties: false
      security:
        - apiKey: []
components:
  securitySchemes:
    apiKey:
      type: http
      scheme: bearer

````